# coding: utf-8

"""
    Container Registry service

    ## Overview Container Registry service enables IONOS clients to manage docker and OCI compliant registries for use by their managed Kubernetes clusters. Use a Container Registry to ensure you have a privately accessed registry to efficiently support image pulls. ## Changelog ### 1.1.0  - Added new endpoints for Repositories  - Added new endpoints for Artifacts  - Added new endpoints for Vulnerabilities  - Added registry vulnerabilityScanning feature   # noqa: E501

    The version of the OpenAPI document: 1.1.0
    Contact: support@cloud.ionos.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ionoscloud_container_registry.configuration import Configuration


class PaginationLinks(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {

        'next': 'str',

        'previous': 'str',

        'var_self': 'str',
    }

    attribute_map = {

        'next': 'next',

        'previous': 'previous',

        'var_self': 'self',
    }

    def __init__(self, next=None, previous=None, var_self=None, local_vars_configuration=None):  # noqa: E501
        """PaginationLinks - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._next = None
        self._previous = None
        self._var_self = None
        self.discriminator = None

        self.next = next
        self.previous = previous
        self.var_self = var_self


    @property
    def next(self):
        """Gets the next of this PaginationLinks.  # noqa: E501


        :return: The next of this PaginationLinks.  # noqa: E501
        :rtype: str
        """
        return self._next

    @next.setter
    def next(self, next):
        """Sets the next of this PaginationLinks.


        :param next: The next of this PaginationLinks.  # noqa: E501
        :type next: str
        """
        if self.local_vars_configuration.client_side_validation and next is None:  # noqa: E501
            raise ValueError("Invalid value for `next`, must not be `None`")  # noqa: E501

        self._next = next

    @property
    def previous(self):
        """Gets the previous of this PaginationLinks.  # noqa: E501


        :return: The previous of this PaginationLinks.  # noqa: E501
        :rtype: str
        """
        return self._previous

    @previous.setter
    def previous(self, previous):
        """Sets the previous of this PaginationLinks.


        :param previous: The previous of this PaginationLinks.  # noqa: E501
        :type previous: str
        """
        if self.local_vars_configuration.client_side_validation and previous is None:  # noqa: E501
            raise ValueError("Invalid value for `previous`, must not be `None`")  # noqa: E501

        self._previous = previous

    @property
    def var_self(self):
        """Gets the var_self of this PaginationLinks.  # noqa: E501


        :return: The var_self of this PaginationLinks.  # noqa: E501
        :rtype: str
        """
        return self._var_self

    @var_self.setter
    def var_self(self, var_self):
        """Sets the var_self of this PaginationLinks.


        :param var_self: The var_self of this PaginationLinks.  # noqa: E501
        :type var_self: str
        """
        if self.local_vars_configuration.client_side_validation and var_self is None:  # noqa: E501
            raise ValueError("Invalid value for `var_self`, must not be `None`")  # noqa: E501

        self._var_self = var_self
    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaginationLinks):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaginationLinks):
            return True

        return self.to_dict() != other.to_dict()
